
IF(DEFINED NLIB_IMPORT_N)
  RETURN()
ENDIF()

IF(${CMAKE_BUILD_TYPE} MATCHES "Debug")
  SET(NLIB_POSTFIX ${CMAKE_DEBUG_POSTFIX})
ELSE()
  SET(NLIB_POSTFIX ${CMAKE_RELEASE_POSTFIX})
ENDIF()

IF(BUILD_SHARED_LIBS)
  SET(NLIB_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
  SET(NLIB_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
  SET(NLIB_LIBTYPE SHARED)
ELSE()
  SET(NLIB_PREFIX ${CMAKE_STATIC_LIBRARY_PREFIX})
  SET(NLIB_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
  SET(NLIB_LIBTYPE STATIC)
ENDIF()

IF(NOT EXISTS "${NLIB_RELEASE_ROOT}/include")
  FILE(MAKE_DIRECTORY "${NLIB_RELEASE_ROOT}/include")
ENDIF()

#
# libn
#
IF(NOT TARGET n)
  ADD_LIBRARY(n ${NLIB_LIBTYPE} IMPORTED)
  SET_PROPERTY(TARGET n PROPERTY IMPORTED_LOCATION "${NLIB_DIR}/${NLIB_PREFIX}n${NLIB_POSTFIX}${NLIB_SUFFIX}")
  SET_PROPERTY(TARGET n PROPERTY IMPORTED_LOCATION_RELEASE "${NLIB_DIR}/${NLIB_PREFIX}n${CMAKE_RELEASE_POSTFIX}${NLIB_SUFFIX}")
  SET_PROPERTY(TARGET n PROPERTY IMPORTED_LOCATION_DEBUG "${NLIB_DIR}/${NLIB_PREFIX}n${CMAKE_DEBUG_POSTFIX}${NLIB_SUFFIX}")
  SET_PROPERTY(TARGET n PROPERTY IMPORTED_IMPLIB "${NLIB_DIR}/${CMAKE_IMPORT_LIBRARY_PREFIX}n${NLIB_POSTFIX}${CMAKE_IMPORT_LIBRARY_SUFFIX}")
  SET_PROPERTY(TARGET n PROPERTY IMPORTED_IMPLIB_RELEASE "${NLIB_DIR}/${CMAKE_IMPORT_LIBRARY_PREFIX}n${CMAKE_RELEASE_POSTFIX}${CMAKE_IMPORT_LIBRARY_SUFFIX}")
  SET_PROPERTY(TARGET n PROPERTY IMPORTED_IMPLIB_DEBUG "${NLIB_DIR}/${CMAKE_IMPORT_LIBRARY_PREFIX}n${CMAKE_DEBUG_POSTFIX}${CMAKE_IMPORT_LIBRARY_SUFFIX}")
  IF(DEFINED NLIB_PKGROOT_DIR)
    SET_PROPERTY(TARGET n APPEND PROPERTY INCLUDE_DIRECTORIES "${NLIB_PKGROOT_DIR}/../misc/nsources")
  ENDIF()
ENDIF()
SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${NLIB_RELEASE_ROOT}/include")
IF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "/usr/local/include")
ENDIF()
# SET_PROPERTY(TARGET n PROPERTY NO_SYSTEM_FROM_IMPORTED TRUE)  # avoid -isystem
SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_COMPILE_DEFINITIONS "__STDC_FORMAT_MACROS;__STDC_WANT_SECURE_LIB__=1")
IF(NOT WIN32 AND NOT NX)
  SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_COMPILE_DEFINITIONS "__STDC_LIMIT_MACROS;__STDC_CONSTANT_MACROS")
ENDIF()
IF(UNIX)
  IF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    LINK_DIRECTORIES(/usr/local/lib)
    SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_LINK_LIBRARIES dispatch pthread rt execinfo)
  ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_LINK_LIBRARIES pthread)
  ELSEIF(NOT NLIB_ANDX)
    SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_LINK_LIBRARIES pthread rt)
	  IF (EXISTS "/etc/fedora-release")
		  # Fedora sometimes needs explict -latomic
		  SET_PROPERTY(TARGET n APPEND PROPERTY INTERFACE_LINK_LIBRARIES atomic)
	  ENDIF()
  ENDIF()
ENDIF()

SET(NLIB_IMPORT_N TRUE)
