﻿
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_
#define INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_

#include "nn/nlib/InputStream.h"
#include "nn/nlib/InputConverterStream.h"
#include "nn/nlib/Base64.h"

NLIB_NAMESPACE_BEGIN
class NLIB_VIS_PUBLIC Base64InputStream NLIB_FINAL : public InputConverterStream {
 public:
    typedef Base64Decoder::CharOption CharOption;
    NLIB_CEXPR Base64InputStream() NLIB_NOEXCEPT : prv_(nullptr) {}
    errno_t Init(CharOption char_option) NLIB_NOEXCEPT;
    errno_t Init() NLIB_NOEXCEPT { return Init(Base64Decoder::kBase64Default); }
    virtual ~Base64InputStream() NLIB_NOEXCEPT NLIB_OVERRIDE;

 private:
    struct Base64InputStreamPrivate;
    Base64InputStreamPrivate* prv_;
    NLIB_DISALLOW_COPY_AND_ASSIGN(Base64InputStream);
};
NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_
