﻿
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_BASE64OUTPUTSTREAM_H_
#define INCLUDE_NN_NLIB_BASE64OUTPUTSTREAM_H_

#include "nn/nlib/OutputStream.h"
#include "nn/nlib/OutputConverterStream.h"
#include "nn/nlib/Base64.h"

NLIB_NAMESPACE_BEGIN
class NLIB_VIS_PUBLIC Base64OutputStream NLIB_FINAL : public OutputConverterStream {
 public:
    // NOTE: define NewLineMode (not typedef) again for doxygen.
    typedef Base64Encoder::CharOption CharOption;
    enum NewLineMode { kNewLineModeNone = 0, kNewLineModeCrlf, kNewLineModeLf };
    NLIB_CEXPR Base64OutputStream() NLIB_NOEXCEPT : prv_(nullptr) {}
    errno_t Init(CharOption char_option) NLIB_NOEXCEPT;
    errno_t Init() NLIB_NOEXCEPT { return Init(Base64Encoder::kBase64Default); }
    virtual ~Base64OutputStream() NLIB_NOEXCEPT NLIB_OVERRIDE;
    void SetNewLineMode(NewLineMode mode) NLIB_NOEXCEPT;

 private:
    struct Base64OutputStreamPrivate;
    Base64OutputStreamPrivate* prv_;
    NLIB_DISALLOW_COPY_AND_ASSIGN(Base64OutputStream);
};
NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_BASE64OUTPUTSTREAM_H_
