﻿
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_CAFE_H_
#define INCLUDE_NN_NLIB_CONFIG_CAFE_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
#error do not include directly
#endif
#ifdef CAFE

// Platform_cafe.cpp(MEMAllocFromDefaultHeapEx(size, boundary))
extern "C" void* memalign(size_t boundary, size_t size);

typedef int FSStatus;
extern "C" extern FSStatus SAVEInit();
extern "C" extern void SAVEShutdown();
extern "C" extern void FSInit();
extern "C" extern void FSShutdown();

#define NLIB_PATHMAPPER_FORSAMPLE                                               \
    nlib_ns::NativePathMapper g_pathmapper;                                     \
    nlib_ns::NativePathMapper& g_PathMapper = g_pathmapper;                     \
    inline void InitPathMapperForSample() {                                     \
        g_pathmapper.AddMap("/vol/save/nlibsample/", "nlibpath:///readonly/");  \
        g_pathmapper.AddMap("/vol/save/nlibsample/", "nlibpath:///readwrite/"); \
    }

#define NLIB_MAINFUNC                          \
    int main(int argc, char** argv) {          \
        FSInit();                              \
        SAVEInit();                            \
        bool result = SampleMain(argc, argv);  \
        nlib_printf(result ? "OK\n" : "NG\n"); \
        SAVEShutdown();                        \
        FSShutdown();                          \
        return result ? 0 : 1;                 \
    }

#define NLIB_ASSERT ASSERT
#define NLIB_ASSERT_NOERR(e) ASSERTMSG(((e) == 0), "%s", nlib_error_string(e))

#define NLIB_ALIGNAS(x) __attribute__((aligned(x)))
#define NLIB_ALIGNOF(tp) __alignof__(tp)

#define NLIB_CXX11_EXTERN_TEMPLATES

#define NLIB_STD_SWAP_WORKAROUND

#define NLIB_CXX11_SWAPHEADER

#define NLIB_HAS_VIRTUALMEMORY

#endif
#endif  // INCLUDE_NN_NLIB_CONFIG_CAFE_H_
