﻿
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_GCC_H_
#define INCLUDE_NN_NLIB_CONFIG_GCC_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
#error do not include directly
#endif

#if defined(__GNUC__)

#if __GNUC__ < 5
#error Use gcc 5.x or above
#endif

#if __cplusplus < 201103L
#error Use C++11 or later
#endif

#if defined(__EXCEPTIONS) && !defined(__cpp_exceptions)
#define __cpp_exceptions 199711L
#endif

#if __cplusplus >= 201103L
#ifndef __cpp_static_assert
#define __cpp_static_assert 200410L  // N1720
#endif

#define NLIB_CXX11_NULL_POINTER_CONSTANT
#ifndef __cpp_rvalue_references
#define __cpp_rvalue_references 200610L  // N2118
#endif

#ifndef __cpp_lambdas
#define __cpp_lambdas 200907L  // N2927
#endif

#ifndef __cpp_range_based_for
#define __cpp_range_based_for 200907L  // N2930
#endif

#ifndef __cpp_alias_templates
#define __cpp_alias_templates 200704L  // N2258
#endif

#ifndef __cpp_variadic_templates
#define __cpp_variadic_templates 200704L  // N2242
#endif

#ifndef __cpp_delegating_constructors
#define __cpp_delegating_constructors 200604L  // N1986
#endif

#ifndef __cpp_constexpr
#define __cpp_constexpr 200704  // N2235
#endif

#define NLIB_CXX11_EXTERN_TEMPLATES
#define NLIB_CXX11_DEFAULTED_AND_DELETED_FUNCTIONS
#define NLIB_CXX11_EXPLICIT_CONVERSION_OPERATORS
#define NLIB_CXX11_EXPLICIT_VIRTUAL_OVERRIDES
#define NLIB_CXX11_ALIGNMENT_SUPPORT
#define NLIB_CXX11_DEFAULT_TEMPLATE_ARGUMENT_FOR_FUNCTION_TEMPLATES
#define NLIB_CXX11_ALIGNMENT_SUPPORT
#endif

// #include <bits/c++config.h>
// #ifndef __GLIBCXX__
// # error c++config.h should define __GLIBCXX__ ...
// #endif

#define NLIB_CXX11_UNIQUEPTR
#define NLIB_CXX11_STDLIB_ARRAY
#define NLIB_CXX11_STDLIB_UNORDERED
#define NLIB_CXX11_STDLIB_TUPLE
#define NLIB_HAS_NATIVE_TYPETRAITS
#define NLIB_CXX11_STDLIB_RANDOM
#define NLIB_CXX11_STDLIB_CHRONO
#define NLIB_CXX11_STDLIB_ATOMIC

#ifndef __cpp_raw_strings
#define __cpp_raw_strings 200710L  // N2442
#endif
#ifndef __cpp_unicode_literals
#define __cpp_unicode_literals 200710L  // N2442
#endif
#ifndef __cpp_user_defined_literals
#define __cpp_user_defined_literals 200809L  // N2765
#endif
#ifndef __cpp_decltype
#define __cpp_decltype 200707L  // N2343
#endif
#ifndef __cpp_attributes
#define __cpp_attributes 200809L  // N2761
#endif
#ifndef __cpp_initializer_lists
#define __cpp_initializer_lists 200806L  // N2672
#endif
#ifndef __cpp_nsdmi
#define __cpp_nsdmi 200809L  // N2756
#endif
#ifndef __cpp_inheriting_constructors
#define __cpp_inheriting_constructors 200802L  // N2540
#endif
#ifndef __cpp_ref_qualifiers
#define __cpp_ref_qualifiers 200710L  // N2439
#endif
#ifndef __cpp_decltype_auto
#define __cpp_decltype_auto 201304L  // N3638
#endif
#ifndef __cpp_lib_complex_udls
#define __cpp_lib_complex_udls 201309L  // N3779
#endif
#ifndef __cpp_lib_tuple_element_t
#define __cpp_lib_tuple_element_t 201402L  // N3887
#endif

#if __cplusplus > 201103L
#ifndef __cpp_binary_literals
#define __cpp_binary_literals 201304L  // N3472
#endif
#ifndef __cpp_init_captures
#define __cpp_init_captures 201304L  // N3648
#endif
#ifndef __cpp_generic_lambdas
#define __cpp_generic_lambdas 201304L  // N3649
#endif
#ifndef __cpp_return_type_deduction
#define __cpp_return_type_deduction 201304L  // N3638
#endif
#ifndef __cpp_lib_shared_timed_mutex
#define __cpp_lib_shared_timed_mutex 201402L  // N3891
#endif
#ifndef __cpp_lib_is_null_pointer
#define __cpp_lib_is_null_pointer 201309L  // LWG2247
#endif
#ifndef __cpp_lib_generic_associative_lookup
#define __cpp_lib_generic_associative_lookup 201304L  // N3657
#endif
#ifndef __cpp_lib_null_iterators
#define __cpp_lib_null_iterators 201304L  // N3644
#endif
#endif

#include <cassert>
#define NLIB_ASSERT assert

#define NLIB_ALIGNAS(x) __attribute__((aligned(x)))
#define NLIB_ALIGNOF(tp) __alignof__(tp)

#endif
#endif  // INCLUDE_NN_NLIB_CONFIG_GCC_H_
