
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_OSX_H_
#define INCLUDE_NN_NLIB_CONFIG_OSX_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
#error do not include directly
#endif

#include <mach-o/dyld.h>
#include <TargetConditionals.h>

#if defined(__clang__)
#include "nn/nlib/Config_clang.h"
#else
#error
#endif

#define NLIB_HAS_VIRTUALMEMORY

#define NLIB_PATHMAPPER_FORSAMPLE                                                \
    nlib_ns::NativePathMapper g_pathmapper;                                      \
    nlib_ns::NativePathMapper& g_PathMapper = g_pathmapper;                      \
    inline void InitPathMapperForSample() {                                      \
        g_pathmapper.AddMap(CMAKE_CURRENT_BINARY_DIR, "nlibpath:///readonly/");  \
        g_pathmapper.AddMap(CMAKE_CURRENT_BINARY_DIR, "nlibpath:///readwrite/"); \
    }

/*
#define NLIB_PATHMAPPER_FORSAMPLE \
    nlib_ns::NativePathMapper g_pathmapper; \
    inline void InitPathMapperForSample() { \
        char dir[1024]; \
        uint32_t size = sizeof(dir); \
        _NSGetExecutablePath(dir, &size); \
        *const_cast<char*>(nlib_strrchr(dir, '/')) = '\0'; \
        g_pathmapper.AddMap(dir, "nlibpath:///readonly/"); \
        g_pathmapper.AddMap(dir, "nlibpath:///readwrite/"); \
    }
*/

#ifndef NLIB_OSX_MAINFUNC_NAME
#define NLIB_OSX_MAINFUNC_NAME main
#endif

#define NLIB_MAINFUNC                                              \
    extern "C" int NLIB_OSX_MAINFUNC_NAME(int argc, char** argv) { \
        bool result = SampleMain(argc, argv);                      \
        nlib_printf(result ? "OK\n" : "NG\n");                     \
        return result ? 0 : 1;                                     \
    }

#ifdef __cpp_exceptions
#define NLIB_THREAD_EXIT_CPP_THROW_NLIB_EXCEPTION
#undef nlib_thread_cleanup_push
#undef nlib_thread_cleanup_pop
#define nlib_thread_cleanup_push(fn, arg) \
    pthread_cleanup_push(fn, arg);        \
    try {
#define nlib_thread_cleanup_pop(exec)     \
    }                                     \
    catch (...) {                         \
        { pthread_cleanup_pop(1) throw; } \
        pthread_cleanup_pop(exec)
#endif

#endif  // INCLUDE_NN_NLIB_CONFIG_OSX_H_
