﻿
#pragma once
#ifndef INCLUDE_NN_NLIB_OSS_LZ4OUTPUTSTREAM_H_
#define INCLUDE_NN_NLIB_OSS_LZ4OUTPUTSTREAM_H_

#include "lz4frame.h"
#include "nn/nlib/Config.h"
#include "nn/nlib/InputStream.h"
#include "nn/nlib/InputConverterStream.h"

#if defined(_MSC_VER) && defined(nx_oss_lz4_EXPORTS)
#undef NLIB_VIS_PUBLIC
#define NLIB_VIS_PUBLIC NLIB_WINEXPORT
#endif

NLIB_NAMESPACE_BEGIN
namespace oss {

class Lz4InputStreamSettings {
 public:
    NLIB_CEXPR Lz4InputStreamSettings() NLIB_NOEXCEPT {}
};

class NLIB_VIS_PUBLIC Lz4InputStream NLIB_FINAL : public InputConverterStream {
 public:
    NLIB_CEXPR Lz4InputStream() NLIB_NOEXCEPT : prv_(nullptr) {}
    virtual ~Lz4InputStream() NLIB_NOEXCEPT NLIB_OVERRIDE;
    errno_t Init() NLIB_NOEXCEPT {
        NLIB_CEXPR Lz4InputStreamSettings settings;
        return this->Init(settings);
    }
    errno_t Init(const Lz4InputStreamSettings& settings) NLIB_NOEXCEPT;

 private:
    struct Lz4InputStreamPrivate;
    Lz4InputStreamPrivate* prv_;
    NLIB_DISALLOW_COPY_AND_ASSIGN(Lz4InputStream);
};

}  // namespace oss
NLIB_NAMESPACE_END

#if defined(_MSC_VER) && defined(nx_oss_lz4_EXPORTS)
#undef NLIB_VIS_PUBLIC
#define NLIB_VIS_PUBLIC NLIB_WINIMPORT
#endif

#endif  // INCLUDE_NN_NLIB_OSS_LZ4OUTPUTSTREAM_H_
