﻿
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_TESTING_PARAMTYPETYPES_H_
#define INCLUDE_NN_NLIB_TESTING_PARAMTYPETYPES_H_

#include "nn/nlib/Config.h"

NLIB_NAMESPACE_BEGIN
namespace testing {

#ifdef __cpp_variadic_templates
struct Tp0 {};
template<class HEAD, class... TAIL>
struct Types {
    typedef HEAD Head;
    typedef Types<TAIL...> Tail;
    typedef Types<HEAD, TAIL...> type;
};
template<class HEAD>
struct Types<HEAD> {
    typedef HEAD Head;
    typedef Tp0 Tail;
    typedef Types<HEAD> type;
};
template<>
struct Types<Tp0> {
    typedef Types<Tp0> type;
};
#else
struct None {};
struct Tp0 {};
template<class T1>
struct Tp1 {
    typedef T1 Head;
    typedef Tp0 Tail;
};
template<class T1, class T2>
struct Tp2 {
    typedef T1 Head;
    typedef Tp1<T2> Tail;
};
template<class T1, class T2, class T3>
struct Tp3 {
    typedef T1 Head;
    typedef Tp2<T2, T3> Tail;
};
template<class T1, class T2, class T3, class T4>
struct Tp4 {
    typedef T1 Head;
    typedef Tp3<T2, T3, T4> Tail;
};
template<class T1, class T2, class T3, class T4, class T5>
struct Tp5 {
    typedef T1 Head;
    typedef Tp4<T2, T3, T4, T5> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6>
struct Tp6 {
    typedef T1 Head;
    typedef Tp5<T2, T3, T4, T5, T6> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7>
struct Tp7 {
    typedef T1 Head;
    typedef Tp6<T2, T3, T4, T5, T6, T7> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8>
struct Tp8 {
    typedef T1 Head;
    typedef Tp7<T2, T3, T4, T5, T6, T7, T8> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9>
struct Tp9 {
    typedef T1 Head;
    typedef Tp8<T2, T3, T4, T5, T6, T7, T8, T9> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10>
struct Tp10 {
    typedef T1 Head;
    typedef Tp9<T2, T3, T4, T5, T6, T7, T8, T9, T10> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11>
struct Tp11 {
    typedef T1 Head;
    typedef Tp10<T2, T3, T4, T5, T6, T7, T8, T9, T10, T11> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11, class T12>
struct Tp12 {
    typedef T1 Head;
    typedef Tp11<T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11, class T12, class T13>
struct Tp13 {
    typedef T1 Head;
    typedef Tp12<T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11, class T12, class T13, class T14>
struct Tp14 {
    typedef T1 Head;
    typedef Tp13<T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14> Tail;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11, class T12, class T13, class T14, class T15>
struct Tp15 {
    typedef T1 Head;
    typedef Tp14<T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15> Tail;
};

template<class T1 = None, class T2 = None, class T3 = None, class T4 = None, class T5 = None,
         class T6 = None, class T7 = None, class T8 = None, class T9 = None, class T10 = None,
         class T11 = None, class T12 = None, class T13 = None, class T14 = None, class T15 = None>
struct Types {
    typedef Tp15<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15> type;
};

template<>
struct Types<None, None, None, None, None, None, None, None, None, None, None, None, None, None,
             None> {
    typedef Tp0 type;
};
template<class T1>
struct Types<T1, None, None, None, None, None, None, None, None, None, None, None, None, None,
             None> {
    typedef Tp1<T1> type;
};
template<class T1, class T2>
struct Types<T1, T2, None, None, None, None, None, None, None, None, None, None, None, None, None> {
    typedef Tp2<T1, T2> type;
};
template<class T1, class T2, class T3>
struct Types<T1, T2, T3, None, None, None, None, None, None, None, None, None, None, None, None> {
    typedef Tp3<T1, T2, T3> type;
};
template<class T1, class T2, class T3, class T4>
struct Types<T1, T2, T3, T4, None, None, None, None, None, None, None, None, None, None, None> {
    typedef Tp4<T1, T2, T3, T4> type;
};
template<class T1, class T2, class T3, class T4, class T5>
struct Types<T1, T2, T3, T4, T5, None, None, None, None, None, None, None, None, None, None> {
    typedef Tp5<T1, T2, T3, T4, T5> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6>
struct Types<T1, T2, T3, T4, T5, T6, None, None, None, None, None, None, None, None, None> {
    typedef Tp6<T1, T2, T3, T4, T5, T6> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7>
struct Types<T1, T2, T3, T4, T5, T6, T7, None, None, None, None, None, None, None, None> {
    typedef Tp7<T1, T2, T3, T4, T5, T6, T7> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8>
struct Types<T1, T2, T3, T4, T5, T6, T7, T8, None, None, None, None, None, None, None> {
    typedef Tp8<T1, T2, T3, T4, T5, T6, T7, T8> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9>
struct Types<T1, T2, T3, T4, T5, T6, T7, T8, T9, None, None, None, None, None, None> {
    typedef Tp9<T1, T2, T3, T4, T5, T6, T7, T8, T9> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10>
struct Types<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, None, None, None, None, None> {
    typedef Tp10<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11>
struct Types<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, None, None, None, None> {
    typedef Tp11<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11, class T12>
struct Types<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, None, None, None> {
    typedef Tp12<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11, class T12, class T13>
struct Types<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, None, None> {
    typedef Tp13<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13> type;
};
template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9,
         class T10, class T11, class T12, class T13, class T14>
struct Types<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, None> {
    typedef Tp14<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14> type;
};
#endif

}  // namespace testing
NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_TESTING_PARAMTYPETYPES_H_
