nlib_add_sample(succinct bitvector nx_succinct)
nlib_add_sample(succinct detection nx_succinct)
nlib_add_sample(succinct ngc nx_succinct)
nlib_add_sample(succinct simple nx_succinct)
IF (NOT CAFE AND NOT CTR)
	IF(NOT MSVC_VERSION OR MSVC_VERSION VERSION_GREATER 1800)
		nlib_add_sample(succinct snippet nx_succinct)
    ENDIF()
ENDIF()

IF(CTR)
	nlib_cygwin_getcygpath(${PROJECT_BINARY_DIR}/resource MY_DIR)
	SET_PROPERTY(TARGET succinct_detection APPEND PROPERTY
		COMPILE_DEFINITIONS "NLIB_CTR_SAMPLE_USEFILE")
	nlib_cygwin_getwinpath(${MY_DIR} respath)
	FILE(WRITE ${PROJECT_BINARY_DIR}/CMakeFiles/succinct_detection.dir/detection.rsf
		"BasicInfo:\n"
		"  BackupMemoryType: None\n"
		"  Title: detection\n"
		"Rom:\n"
		"  HostRoot: ${respath}\n"
		"CardInfo:\n"
		"  CardDevice: None\n"
		"TitleInfo:\n"
		"  UniqueId: 0xff3f\n"
		"AccessControlInfo:\n"
		"  FileSystemAccess:\n"
		"    - Debug\n"
		"    - DirectSdmc\n"
	)
	SET_PROPERTY(TARGET succinct_detection PROPERTY
		CTR_SPEC_RSF "${PROJECT_BINARY_DIR}/CMakeFiles/succinct_detection.dir/detection.rsf")
	generate_ctr_makeromopt(succinct_detection)
ENDIF()

IF(NOT TARGET ac)
	nlib_add_executable(ac IMPORTED)
	SET_PROPERTY(TARGET ac PROPERTY IMPORTED_LOCATION "${NLIB_TOOL_DIR}/ac")
ELSE()
#	SET(AC ac)
ENDIF()

# IF(UNIX AND NOT CYGWIN)
# 	SET(LD_LIBPATH "LD_LIBRARY_PATH=${NLIB_DIR}")
# ELSE()
# 	UNSET(LD_LIBPATH)
# ENDIF()

IF(CAFE)
	IF($ENV{CAFE_SAVE_DIR})
		nlib_cygwin_getcygpath($ENV{CAFE_SAVE_DIR}/nlibsample MY_DIR)
	ELSE()
		nlib_cygwin_getcygpath($ENV{CAFE_ROOT}/data/save/nlibsample MY_DIR)
	ENDIF()
	GET_FILENAME_COMPONENT(MY_DIR ${MY_DIR} ABSOLUTE)
ELSEIF(CTR)
	FILE(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/resource)
	nlib_cygwin_getcygpath(${PROJECT_BINARY_DIR}/resource MY_DIR)
	GET_FILENAME_COMPONENT(MY_DIR ${MY_DIR} ABSOLUTE)
ELSE()
	SET(MY_DIR "$<TARGET_FILE_DIR:succinct_detection>")
ENDIF()

ADD_CUSTOM_COMMAND(TARGET succinct_detection POST_BUILD
				   COMMAND ${CMAKE_COMMAND} -E copy_if_different
                   "${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/adjv.txt"
                   "${MY_DIR}")
ADD_CUSTOM_COMMAND(TARGET succinct_detection POST_BUILD
				   COMMAND ${CMAKE_COMMAND} -E copy_if_different
                   "${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/kokoro.txt"
				   "${MY_DIR}")
ADD_CUSTOM_COMMAND(TARGET succinct_detection POST_BUILD
				   COMMAND ${CMAKE_COMMAND} -E copy_if_different
                   "${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/shayo.txt"
				   "${MY_DIR}")
ADD_CUSTOM_COMMAND(TARGET succinct_detection POST_BUILD
				   COMMAND ac
				   "--output_file=${MY_DIR}/adjv.ac" "--input_file=${MY_DIR}/adjv.txt")

IF(NOT CTR)
	IF (NOT CAFE)
		SET(MY_DIR "$<TARGET_FILE_DIR:succinct_kwlink>")
	ENDIF()
	# release build only(heavy)
	nlib_add_sample(succinct kwlink nx_succinct CONFIGURATIONS Release)
	ADD_CUSTOM_COMMAND(TARGET succinct_kwlink POST_BUILD
					COMMAND ${CMAKE_COMMAND} -E copy_if_different
					"${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/wikipedia.txt"
					"${MY_DIR}")
	ADD_CUSTOM_COMMAND(TARGET succinct_kwlink POST_BUILD
					COMMAND ac
					"--output_file=${MY_DIR}/wikipedia.ac" "--input_file=${MY_DIR}/wikipedia.txt")
ENDIF()
